#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
'#include "debug.inc"

SUB progress(hText AS LONG, pct AS DOUBLE)
   'smooth progress bar with text
   'hText = handle of textbox
   'pct = percent progress
   '------------------------------------------------------------
   LOCAL hParent, n AS LONG
   LOCAL xb, yb, wb, hb, xc, yc, wc, hc, xt, yt AS LONG
   LOCAL hdc, hRgn, hFont, hBrush AS LONG
   LOCAL sz AS ASCIIZ * 1024
   LOCAL pt AS POINT, rBox, tBox AS RECT
   LOCAL lf AS LOGFONT

   'get location and size of client textbox
   n = GetWindowTextLength(hText)
   GetWindowText hText, sz, n + 1
   hParent = GetParent(hText)
   ClientToScreen hParent, pt
   GetWindowRect hText, rBox
   xb = rBox.nLeft - pt.x: yb = rBox.nTop - pt.y
   wb = rBox.nRight - rBox.nLeft: hb = rBox.nBottom - rBox.nTop
   GetClientRect hText, rBox
   wc = rBox.nRight: hc = rBox.nBottom
   xc = xb + (wb - wc)/2: yc = yb + (hb - hc)/2

   'paint progress area of textbox
   hdc = getDC(hParent)
   hBrush = CreateSolidBrush(%RGB_LIGHTBLUE)
   hRgn = CreateRectRgn(xc, yc, xc + wc * pct, yc + hc)
   FillRgn hdc, hRgn, hBrush
   DeleteObject hBrush
   DeleteObject hRgn
   ReleaseDC hParent, hdc

   'print the text back onto the progress area
   hdc = getDC(hText)
   hFont = SendMessage(hText, %WM_GETFONT, 0, 0)
   SelectObject(hdc, hFont)
   SendMessage hText, %EM_GETRECT, 0, VARPTR(tBox)
   xt = tBox.nLeft: yt = tBox.nTop
   SetBkMode(hdc, %TRANSPARENT)
   TextOut hdc, xt, yt, BYVAL VARPTR(sz), LEN(sz)
   ReleaseDC hText, hdc
END SUB

FUNCTION PBMAIN
   LOCAL hDlg AS LONG
   DIALOG NEW PIXELS, 0, "Progress Bar Demo", , , 300, 120, %WS_CAPTION OR %WS_OVERLAPPEDWINDOW TO hDlg
   CONTROL ADD TEXTBOX, hDlg, 101, "", 20, 30, 260, 20
   CONTROL ADD BUTTON, hDlg, 102, "Begin", 150, 70, 80, 35
   DIALOG SHOW MODAL hDlg, CALL dlgProc
END FUNCTION

CALLBACK FUNCTION dlgProc()
   LOCAL i, hText AS LONG, pct AS DOUBLE
   STATIC txt AS STRING
   SELECT CASE AS LONG CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 101
         CONTROL SEND CB.HNDL, 101, %EM_SETSEL, -1, 0
         txt = "This is a measure of the progress"
         CONTROL SET TEXT CB.HNDL, 101, txt
      CASE %WM_COMMAND
         IF CB.CTL = 102 THEN
            CONTROL SET TEXT CB.HNDL, 101, txt
            CONTROL HANDLE CB.HNDL, 101 TO hText
            progress hText, 0.25
            FUNCTION = 1
            SLEEP 4000
            'FOR i = 1 TO 2  '100
            '   progress hText, i/2  '100
            '   DIALOG DOEVENTS: SLEEP 40
            'NEXT i
         END IF
   END SELECT
END FUNCTION
