#COMPILE EXE
#DIM ALL
#INCLUDE "debug.inc"
#INCLUDE "wIN32api.inc"

FUNCTION PBMAIN()
   local sourceFile, targetFile as string
   local buffSize, totalBytes as dword
   'sourceFile = "c:\pbwin10\my Backup_Update\test.exe"
   sourceFile = "c:\Junk\USAARTS.MDB"
   targetFile = "c:\junk2\USAARTS.MDB"
   buffSize = 65536
   totalBytes = fileBlockCopy(sourceFile, targetFile, buffSize) 
   debug str$(totalBytes) + " bytes written"
   debug "done"
END FUNCTION

function fileBlockcopy(sSource as string, sTarget as string, buffSize as dword) as dword
   'copies file in blocks using win32API... useful when needing more continuous status 
   'sSource: file to copy
   'sTarget: file target of copy
   'buffSize: size of blocks to copy (eg. 8192, 65536, 1000000)
   'returns bytes copied
   'returns -1 if sSource not found, -2 if sTarget folder not found
   '-------------------------------------------------------------------------------------------
   local fSource, fTarget as asciiz * 128
   local hSource, hTarget, hTemplateFile, totalBytes as dword
   local bytesRead, bytesWritten as dword, nErr as long
   local pBuff as byte ptr, psa as SECURITY_ATTRIBUTES ptr
   local ofs as OFSTRUCT  ', saStruct as SECURITY_ATTRIBUTES
   if isfile(sSource) = 0 then _
      function = -1: end
   if isfolder(pathname$(path, sTarget)) = 0 then _
      function = -2: end
   dim buff(buffSize) as byte
   fSource = sSource
   fTarget = sTarget
   hSource = openFile(fSource, ofs, %OF_READ)
   hTarget = createFile(fTarget, byval %GENERIC_WRITE, byval 0, byval psa, BYVAL %CREATE_ALWAYS, _
      BYVAL %FILE_ATTRIBUTE_NORMAL, byval htemplateFile)
   pBuff = varptr(buff(0))
   do
      nErr = ReadFile(hSource, byval pBuff, buffSize, bytesRead, byval 0)
      if nErr = 0 then bytesRead = 0
      if bytesRead > 0 then 
         nErr = WriteFile(hTarget, pBuff, bytesRead, bytesWritten, byval 0)
         if nErr = %INVALID_HANDLE_VALUE THEN bytesWritten = 0
      else
         bytesWritten = 0
      end if
      DIALOG DOEVENTS 0
      totalBytes = totalBytes + bytesWritten
      debug totalBytes
   loop while (bytesRead > 0) and (bytesRead = bytesWritten)
   _lclose(hSource)
   _lclose(hTarget)
   function = totalBytes
end function
