#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
#INCLUDE "myBackup.inc"
'#INCLUDE "debug.inc"
#RESOURCE RES, "myBackup.res"
'#RESOURCE "myBackup.pbr"
$verNo = "3.00"

FUNCTION PBMAIN()
   LOCAL nStyle AS LONG, ti AS STRING
   ti = "myBackup - Ver " + $verNo
   DIALOG NEW 0, ti, 73, 86, 480, 275, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hDlg
   CONTROL ADD LABEL,  hDlg, -1, "Target:", 15, 10, 25, 10
   CONTROL ADD LABEL,  hDlg, %IDC_TargetTxt, "", 40, 10, 360, 10
   CONTROL ADD BUTTON, hDlg, %IDC_Target, "Copy files to...", 15, 20, 70, 15
   'CONTROL ADD BUTTON, hDlg, %IDC_Refresh, "Refresh", 87, 20, 70, 15
   CONTROL ADD LABEL,  hDlg, -1, "Backup Folders", 15, 50, 70, 10
   nStyle = %WS_TABSTOP OR %LVS_REPORT OR %LVS_NOCOLUMNHEADER OR %LVS_SINGLESEL OR %LVS_SHOWSELALWAYS
   CONTROL ADD LISTVIEW, hDlg, %IDC_Listview, "", 20, 60, 423, 120, nStyle, %WS_EX_CLIENTEDGE
   LISTVIEW SET STYLEXX hDlg, %IDC_Listview, %LVS_EX_CHECKBOXES OR %LVS_EX_FLATSB OR %LVS_EX_GRIDLINES
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 1, "   Backup Folders", 420, 0
   CONTROL ADD TEXTBOX, hDlg, %IDC_Textbox, "", 0, 0, 0, 0, %BS_LEFT
   CONTROL ADD BUTTON, hDlg, %IDC_AddSource, "Add folder to backup", 15, 188, 90, 20
   CONTROL ADD BUTTON, hDlg, %IDC_Except, "Exception folders", 15, 208, 90, 20
   CONTROL ADD BUTTON, hDlg, %IDC_DelSource, "Remove folder", 105, 188, 90, 20
   CONTROL ADD BUTTON, hDlg, %IDC_SetCkboxes, "Clear Selection", 105, 208, 90, 20
   CONTROL ADD BUTTON, hDlg, %IDC_Backup, "Backup", 291, 190, 60, 22  ', %WS_DISABLED
   CONTROL ADD BUTTON, hDlg, %IDC_Close, "Close", 353, 190, 60, 22
   control add label, hDlg, %IDC_Waiting, "", 290, 215, 120, 15
   DIALOG SHOW MODAL hDlg, CALL dlgProc
END FUNCTION

CALLBACK FUNCTION dlgProc()
   LOCAL i, k, m, n, x, y, xx, yy AS LONG, p as dword
   LOCAL hIcon, hInst, hFile, interval, flags, info, nSources AS LONG
   LOCAL day, mo, yr, maxDays AS LONG
   LOCAL s, f, ti, folder, filter, exeFile, src, tar, drive AS STRING
   LOCAL nextBackup, sInterval, sAutoBegin, sDate AS STRING
   LOCAL sz AS STRINGZ*16
   LOCAL r AS RECT
   LOCAL pid AS DWORD
   STATIC helpFile AS ASCIIZ * %MAX_PATH
   'STATIC nDelSource AS LONG
   SELECT CASE AS LONG CB.MSG
      CASE %WM_INITDIALOG
         DIM recent(1 TO 4)
         control set color cb.hndl, %IDC_Waiting, %RED, -1
         addStatusbar CB.HNDL
         hInst = GetModuleHandle(BYVAL %NULL): sz = "shield"
         hIcon = LoadImage(hInst, sz, %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
         origDir = UCASE$(CURDIR$)

         'define Windows data folder
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA) 'for next update
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents"
         dataFolder = dataFolder + "\cgdSoftware\myBackup\"
         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder
         'define Windows startup folder
         startUpFolder = specialFolder(%CSIDL_STARTUP) + "\"
         iniFile = dataFolder + "myBackup.ini"
         helpFile = dataFolder + "myBackup.chm"
         sAutoFile = dataFolder + "autoBackup"

         'open cgd file and then process the data file
         IF ISFILE(iniFile) THEN
            'read recent() from iniFile
            hFile = FREEFILE
            OPEN iniFile FOR INPUT AS #hFile
            FOR i = 1 TO 4
               LINE INPUT #hFile, s
               IF LEN(s) = 0 THEN EXIT FOR
               n = INSTR(-1, s, "\")
               IF n AND UCASE$(LEFT$(s, n - 1)) = UCASE$(dataFolder) THEN s = MID$(s, n + 1)
               INCR m: recent(m) = s
            NEXT i
            CLOSE #hFile
         END IF
         addMenu hDlg
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500 'show window
         hListview = GetDlgItem(hDlg, %IDC_Listview)
         hTextbox = GetDlgItem(hDlg, %IDC_Textbox)
         r.nLeft = %LVIR_BOUNDS
         n = SendMessage (hListview, %LVM_GETITEMRECT, 0, VARPTR(r))
         DIALOG PIXELS hListview, r.nLeft, r.nTop TO UNITS x, y
         DIALOG PIXELS hListview, r.nRight, r.nBottom TO UNITS xx, yy
         IF %PB_REVISION = &H1004 THEN SWAP x, y: SWAP xx, yy
         thisFile = dataFolder + recent(1)
         'IF LEN(thisFile) THEN openTheFile thisFile
         IF isfile(thisFile) THEN 
            openTheFile thisFile
         else
            dialog send cb.hndl, %WM_COMMAND, %IDM_New, 0
         end if   
      CASE %WM_MENUSELECT
         'appropriate menu items dimmed if autoBackup is running
         IF LOWRD(CB.WPARAM) <= 1 AND CB.LPARAM THEN
            IF getProcID("autoBackup.exe") THEN
               m = %MF_ENABLED: n = %MF_GRAYED
            ELSE
               m = %MF_GRAYED: n = %MF_ENABLED
            END IF
            MENU SET STATE hFileMenu, BYCMD %IDM_RunAutoBU, n
            MENU SET STATE hFileMenu, BYCMD %IDM_KillAutoBU, m
            MENU SET STATE hViewMenu, BYCMD %IDM_AutoBUInfo, m
            FUNCTION = 1
         END IF
      CASE %WM_NOTIFY
         IF CB.NMID = %IDC_Listview THEN
             IF CB.NMCODE = %LVN_ITEMCHANGED OR CB.NMCODE = %NM_SETFOCUS THEN
               'show last backup Date in statusbar
               LISTVIEW GET SELECT CB.HNDL, %IDC_Listview TO n
               IF n AND lastDate(n) THEN
                  s = TRIM$(STR$(lastDate(n)))
                  IF LEN(s) < 8 THEN s = "0" + s
                  s = "  " + LEFT$(s, 2) + "-" + MID$(s, 3, 2) + "-" + RIGHT$(s, 4)
               ELSE
                  s = ""
               END IF
               STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 2, 0, s
            ELSEIF CB.NMCODE = %NM_KILLFOCUS THEN
               STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 2, 0, ""
            END IF
         END IF
      CASE %WM_COMMAND
         SELECT CASE AS LONG CB.CTL
            CASE %IDM_New
               IF fileChanged THEN
                  n = MSGBOX("Save this file first?", %MB_ICONQUESTION OR %MB_YESNO, "Save File")
                  IF n = %IDYES THEN saveTheFile
               END IF
               FOR i = 1 TO numSources
                  LISTVIEW DELETE ITEM hDlg, %IDC_Listview, 1
               NEXT i
               thisFile = "": numSources = 0: sCopyTo = ""
               CONTROL SET TEXT hDlg, %IDC_TargetTxt, sCopyTo
               LISTVIEW INSERT ITEM hDlg, %IDC_Listview, 1, 0, ""
               r.nLeft = %LVIR_BOUNDS
               n = SendMessage (hListview, %LVM_GETITEMRECT, 0, VARPTR(r))
               DIALOG PIXELS hListview, r.nLeft, r.nTop TO UNITS x, y
               DIALOG PIXELS hListview, r.nRight, r.nBottom TO UNITS xx, yy
               IF %PB_REVISION = &H1004 THEN SWAP x, y: SWAP xx, yy
               CONTROL SET LOC hDlg, %IDC_Textbox, x + 23, y + 61
               CONTROL SET SIZE hDlg, %IDC_Textbox, xx - x - 3, yy - y
               s = "Define a new configuration with folders to backup and a target"
               CONTROL SET TEXT hDlg, %IDC_Textbox, s
               LISTVIEW DELETE ITEM hDlg, %IDC_Listview, 1
               CONTROL DISABLE CB.HNDL, %IDC_Backup
            CASE %IDM_Open
               IF running THEN EXIT FUNCTION
               IF fileChanged THEN 'file has been changed
                  n = MSGBOX("Save current file?", %MB_ICONQUESTION OR %MB_YESNO, "Current File Changed")
                  IF n = %IDYES THEN saveTheFile
               END IF
               IF fileBackedUp AND n <> %IDYES THEN 'update lastDate() if file has been backed up
                  hFile = FREEFILE
                  OPEN thisFile FOR BINARY AS #hFile
                  SEEK #hFile, lastDatePos
                  FOR i = 0 TO numSources - 1
                     PUT #hFile, , lastDate(i + 1)
                  NEXT i
                  CLOSE #hFile: fileBackedUp = 0
               END IF
               ti = "Open File": folder = dataFolder
               flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               filter = CHR$("myBackup", 0, "*.bku", 0, "All Files", 0, "*.*", 0)
               DISPLAY OPENFILE CB.HNDL,,, ti, folder, filter, "", "bku", flags TO f
               IF LEN(f) AND (LCASE$(f) <> LCASE$(thisFile)) THEN
                  thisFile = f: openTheFile thisFile
               END IF
            CASE %IDM_Save
               IF running THEN EXIT FUNCTION
               n = MSGBOX("Save file now?", %MB_ICONQUESTION OR %MB_YESNO, "Save File")
               IF n = %IDYES THEN saveTheFile
            CASE %IDM_SaveAs
               IF running THEN EXIT FUNCTION ELSE saveAsFile
            CASE %IDM_Backup, %IDM_Restore
               IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
                  IF running THEN 'interrupted
                     running = 0
                  ELSE  'reset the controls and backup now
                     run = CB.CTL - %IDM_Backup: running = 0: backupNow
                     STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 1, 0, thisFile
                     STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 2, 0, ""
                     LISTVIEW RESET hDlg, %IDC_Listview
                     FOR i = 1 TO numSources
                        LISTVIEW INSERT ITEM hDlg, %IDC_Listview, i, 0, sources(i)
                        ListView_SetCheckState hListview, i - 1, 1
                     NEXT i
                     CONTROL SET TEXT CB.HNDL, %IDC_SetCkboxes, "Clear Selection"
                     LISTVIEW VISIBLE hDlg, %IDC_Listview, 1
                     saveIniFile
                     CONTROL POST CB.HNDL, %IDC_Backup, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
                  END IF
               END IF
            CASE %IDM_RunAutoBU
               autoIntervalDlg() 'select interval and specify beginning backup date
               IF autoInterval = 0 THEN EXIT FUNCTION
               'compute next scheduled auto backup date
               sAutoBegin = RIGHT$(autoBegin, 4) + LEFT$(autoBegin, 5)
               sDate = RIGHT$(DATE$, 4) + LEFT$(DATE$, 5)
               'compute next scheduled auto backup date
               IF sAutoBegin <= sDate THEN 'run after specified interval
                  day = VAL(MID$(autoBegin, 4, 2))
                  mo = VAL(MID$(autoBegin, 1, 2))
                  yr = VAL(MID$(autoBegin, 7, 4))
                  maxDays = daysInMonth(mo, yr)
                  day = day + autoInterval
                  IF day > maxDays THEN day = day - maxDays: INCR mo
                  IF mo > 12 THEN mo = 1: INCR yr
                  nextBackup = FORMAT$(mo, "00-") + FORMAT$(day, "00-") + FORMAT$(yr, "0000")
               ELSE 'run on specified date
                  nextBackup = autoBegin
               END IF

               'create autoBackup file
               SETATTR sAutoFile, %NORMAL: KILL sAutoFile
               hFile = FREEFILE
               OPEN sAutoFile FOR BINARY AS #hFile
               n = LEN(thisFile)
               PUT #hFile,, n: PUT #hFile,, thisFile
               PUT #hFile,, autoInterval
               PUT #hFile,, nextBackup
               CLOSE #hFile

               'now run autoBackup and create shortcut in the Startup folder
               exeFile = CURDIR$ + "\autoBackup.exe"
               pid = SHELL(exeFile + " 1", 4)
               createShortcut %CSIDL_STARTUP, "autoBackup.lnk", exeFile, CURDIR$
            CASE %IDM_KillAutoBU
               killProcess "autoBackup.exe"
            CASE %IDM_BackupInfo TO %IDM_AutoBUInfo 'show information
               info = CB.CTL - %IDM_BackupInfo
               ti = CHOOSE$(info + 1, "Backup", "Restore", "Exceptions", "AutoBackup") + " Information"
               IF info = 3 THEN
                  hFile = FREEFILE
                  OPEN sAutoFile FOR BINARY AS #hFile
                  GET #hFile,, n: f = SPACE$(n): GET #hFile,, f
                  GET #hFile,, autoInterval
                  nextBackup = SPACE$(10): GET #hFile,, nextBackup
                  CLOSE #hFile
                  n = autoInterval: IF n > 100 THEN n = 4
                  sInterval = CHOOSE$(n, "daily", "weekly", "bi-weekly", "4-weeks")
                  s = "       AutoBackup file: " + $TAB + f + $CRLF _
                    + "       Backup interval: " + $TAB + sInterval + $CRLF _
                    + "       Next backup date:  " + $TAB + nextBackup + $CRLF
               ELSEIF info = 2 THEN
                  FOR i = 1 TO numExcept
                     s = s + except(i) + $CRLF
                  NEXT i
               ELSE
                  tar = sCopyTo
                  DIM infoSources(1 TO numSources) AS STRING
                  FOR i = 1 TO numSources
                     k = ListView_GetCheckState(hListview, i - 1)
                     IF k THEN infoSources(i) = sources(i): INCR nSources
                  NEXT i
                  FOR i = 1 TO nSources
                     src = infoSources(i): n = INSTR(src, "\")
                     IF info = 1 THEN
                        s = s + tar + MID$(src, n + 1) + "  -->  " + src + $CRLF
                     ELSE
                        s = s + src + "  -->  " + tar + MID$(src, n + 1) + $CRLF
                     END IF
                  NEXT i
               END IF
               myMSGBOX s, %MB_ICONINFORMATION, ti
            case %IDM_Exit
               DIALOG POST CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0 
            CASE %IDM_Exit + 1 TO %IDM_Exit + 4
               n = CBCTL - %IDM_Exit
               f = dataFolder + recent(n)
               if isfile(f) then
                  thisFile = f: openTheFile thisFile
               else
                  msgbox "File not found" + $crlf + $crlf + f + space$(8), %MB_ICONERROR, "File Error"
               end if
            CASE %IDM_LogFile
               if len(copyLog) then
                  copyFileLog
               else
                  p = SHELL("NotePad " + dataFolder + "myBackup.log", 1)
               end if
            CASE %IDM_ReqdSpace
               run = 3
               getReqdSpace
               FOR i = 1 TO numSources
                  ListView_SetCheckState hListview, i - 1, 1
               NEXT i
               CONTROL SET TEXT CB.HNDL, %IDC_SetCkboxes, "Clear Selection"
            CASE %IDM_Help
               HtmlHelp CB.HNDL, helpFile, 0, 0
            CASE %IDM_About
               about
            CASE %IDC_AddSource
               IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
                  s = "Choose folder to backup"
                  DISPLAY BROWSE CB.HNDL, , , s, "C:\", %BIF_NEWDIALOGSTYLE TO src
                  IF LEN(src) THEN
                     INCR numSources: fileChanged = 1
                     REDIM PRESERVE sources(numSources)
                     REDIM PRESERVE lastDate(numSources)
                     src = RTRIM$(src, "\") + "\"
                     sources(numSources) = src
                     LISTVIEW INSERT ITEM CB.HNDL, %IDC_Listview, numSources, 0, src
                     ListView_SetCheckState hListview, numSources - 1, 1
                     lastDate(numSources) = 0
                  END IF
               END IF
               IF numSources THEN
                  CONTROL ENABLE CB.HNDL, %IDC_Backup
               ELSE
                  CONTROL DISABLE CB.HNDL, %IDC_Backup
               END IF
            CASE %IDC_Except
               exceptions()
            CASE %IDC_DelSource
               LISTVIEW GET SELECT CB.HNDL, %IDC_Listview TO k
               IF k = 0 THEN
                  s = "Must first select a source folder"
                  MSGBOX s, %MB_ICONERROR, "Error": EXIT FUNCTION
               END IF
               s = "Remove this source folder now?"
               n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, sources(k) + space$(8))
               IF n = %IDYES THEN
                  DECR numSources: fileChanged = 1
                  FOR i = k TO numSources
                     sources(i) = sources(i + 1)
                     lastDate(i) = lastDate(i + 1)
                  NEXT i
                  LISTVIEW DELETE ITEM CB.HNDL, %IDC_Listview, k
               END IF
               IF numSources THEN
                  CONTROL ENABLE CB.HNDL, %IDC_Backup
               ELSE
                  CONTROL DISABLE CB.HNDL, %IDC_Backup
               END IF
            CASE %IDC_SetCkboxes
               CONTROL GET TEXT CB.HNDL, CB.CTL TO s
               IF s = "Select All" THEN
                  n = 1: s = "Clear Selection"
               ELSE
                  n = 0: s = "Select All"
               END IF
               FOR i = 1 TO numSources
                  ListView_SetCheckState hListview, i - 1, n
               NEXT i
               CONTROL SET TEXT CB.HNDL, CB.CTL, s
            CASE %IDC_Target
               IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
                  s = "Choose folder where to backup"
                  DISPLAY BROWSE CB.HNDL, , , s, "C:\", %BIF_NEWDIALOGSTYLE TO s
                  IF LEN(s) THEN
                     fileChanged = 1: sCopyTo = s
                     sCopyTo = RTRIM$(s, "\") + "\"
                     CONTROL SET TEXT CB.HNDL, %IDC_TargetTxt, sCopyTo
                     STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, ""
                  END IF
               END IF
               IF numSources THEN
                  CONTROL ENABLE CB.HNDL, %IDC_Backup
               ELSE
                  CONTROL DISABLE CB.HNDL, %IDC_Backup
               END IF
            CASE %IDC_Backup
               DIALOG POST CB.HNDL, %WM_COMMAND, %IDM_Backup, 0
            CASE %IDCANCEL, %IDC_Close
               IF running THEN running = -1
               DIALOG post CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         END SELECT
         IF CB.CTL > %IDC_Statusbar THEN
            CONTROL POST CB.HNDL, CB.CTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            IF running THEN
               IF run = 3 THEN
                  running = -1
               ELSE
                  s = "Must stop the Backup before closing the window"
                  MSGBOX s, %MB_ICONWARNING, "Backup still running"
                  running = 0: FUNCTION = 1: EXIT FUNCTION
               END IF
            END IF
            IF fileChanged THEN
               s = "The file has changed... save it before quiting?"
               n = MSGBOX(s, %MB_YESNOCANCEL OR %MB_ICONQUESTION, "Quit Program")
               IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
               IF n = %IDNO THEN EXIT FUNCTION
               IF fileChanged THEN saveTheFile
            END IF
         END IF
   END SELECT
END FUNCTION

sub copyFileLog()
   local ti as string
   local hLog, hFont, nStyle as long
   ti = "Log of Files Copied"
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX or %WS_THICKFRAME
   DIALOG NEW 0, ti, 180, 50, 350, 350, nStyle TO hLog
   nStyle = %ES_MULTILINE or %ES_READONLY or %WS_VSCROLL 
   control add textbox, hLog, %IDC_CopyLog, "", 0, 0, 346, 346, nStyle
   control set text hLog, %IDC_CopyLog, copyLog
   control set color hLog, %IDC_CopyLog, 0, %White
   font new "tacoma", 9 to hFont
   control set font hLog, %IDC_CopyLog, hFont
   'add dummy button to receive focus first and thereby remove selection
   control add button, hLog, 200, "", 0, 0, 0, 0
   control set focus hLog, 200
   DIALOG SHOW MODeless hLog, CALL copyFileProc
end sub

callback function copyFileProc()
   local wi, ht as long
   SELECT CASE AS LONG CB.MSG
      CASE %WM_SIZE
         'code for resizing the window, along with %WS_THICKFRAME
         DIALOG GET CLIENT CB.HNDL TO wi, ht
         CONTROL SET SIZE CB.HNDL, %IDC_copyLog, wi, ht
   end select
end function

FUNCTION addMenu(BYVAL hDlg AS DWORD) AS DWORD
   LOCAL i AS LONG
   LOCAL s AS STRING
   MENU NEW BAR TO hMenu
   'declare menu popups
   MENU NEW POPUP TO hFileMenu
   MENU NEW POPUP TO hViewMenu
   MENU NEW POPUP TO hHelpMenu
   'fill out top menus
   MENU ADD POPUP, hMenu, "File", hFileMenu, %MF_ENABLED
   MENU ADD POPUP, hMenu, "View", hViewMenu, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Help", hHelpMenu, %MF_ENABLED
   'fill out drop down File menu
      MENU ADD STRING, hFileMenu, "New", %IDM_New, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "Open", %IDM_Open, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "Save", %IDM_Save, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "SaveAs", %IDM_SaveAs, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "-", 0, 0
      MENU ADD STRING, hFileMenu, "Backup", %IDM_Backup, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "Restore", %IDM_Restore, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "-", 0, 0
      MENU ADD STRING, hFileMenu, "Run AutoBackup", %IDM_RunAutoBU, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "Kill AutoBackup", %IDM_KillAutoBU, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "-", 0, 0
      MENU ADD STRING, hFileMenu, "Exit", %IDM_Exit, %MF_ENABLED
      MENU ADD STRING, hFileMenu, "-", 0, 0
      FOR i = 1 TO 4 'add recent files to File menu
         s = recent(i)
         IF LEN(s) = 0 THEN EXIT FOR
         IF INSTR(UCASE$(s), origDir) THEN s = PARSE$(s, "\", -1)
         s = "&" + TRIM$(STR$(i)) + " " + s
         MENU ADD STRING, hFileMenu, s, %IDM_Exit + i, %MF_ENABLED
      NEXT i
   'fill out drop down View menu
      MENU ADD STRING, hViewMenu, "Backup Info", %IDM_BackupInfo, %MF_ENABLED
      MENU ADD STRING, hViewMenu, "Restore Info", %IDM_RestorInfo, %MF_ENABLED
      MENU ADD STRING, hViewMenu, "Exceptions", %IDM_Exceptions, %MF_ENABLED
      MENU ADD STRING, hViewMenu, "AutoBackup Info", %IDM_AutoBUInfo, %MF_ENABLED
      MENU ADD STRING, hViewMenu, "-", 0, 0
      MENU ADD STRING, hViewMenu, "Log File", %IDM_LogFile, %MF_ENABLED
      MENU ADD STRING, hViewMenu, "Reqd Disk Space", %IDM_ReqdSpace, %MF_ENABLED
   'fill out drop down Help menu
      MENU ADD STRING, hHelpMenu, "User Help", %IDM_Help, %MF_ENABLED
      MENU ADD STRING, hHelpMenu, "About", %IDM_About, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
END FUNCTION

SUB addStatusbar(hDlg AS LONG)
   LOCAL hdc, hFont, hStatusbar AS LONG
   LOCAL r AS RECT
   CONTROL ADD STATUSBAR, hDlg, %IDC_StatusBar, "", 0, 0, 0, 0
   STATUSBAR SET PARTS hDlg, %IDC_StatusBar, 365, 70, 9999
   hStatusbar = GetDlgItem(hDlg, %IDC_StatusBar)
   SendMessage(hStatusBar, %SB_GetRect, 0, VARPTR(r))
   statusbarLen = r.nright - r.nleft - 4
   hdc = GetDC(hDlg)
   hFont = SendMessage (hDlg, %WM_GETFONT, 0, 0)
   SelectObject hdc, hFont
   SetMapMode (hDC, %MM_TEXT)
   hStatusbarDC = hdc
END SUB

SUB resetStatusbar()
   LOCAL hStatusbar AS LONG
   LOCAL s AS STRING
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, ""
   CONTROL HANDLE hDlg, %IDC_Statusbar TO hStatusbar
   IF ISFILE(thisFile) THEN
      s = fitLongFileName(hStatusbarDC, thisFile, statusbarLen)
      STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, s
   END IF
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, ""
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 3, 0, ""
END SUB

FUNCTION fitLongFileName(hdc AS LONG, s AS STRING, w AS LONG) AS STRING
   'fit long file name in space of w pixels with balanced path name
   '  hdc = handle of window
   '  s   = string to fit
   '  w   = width in pixels
   '-----------------------------------------------------------------
   LOCAL i, j, k, m AS LONG
   LOCAL f AS STRING, sz AS SIZEL
   GetTextExtentPoint32 hdc, BYVAL STRPTR(s), BYVAL LEN(s), sz
   IF sz.cx <= w THEN FUNCTION = s: EXIT FUNCTION
   k = (PARSECOUNT(s, "\") + 1) \ 2
   'find middle part of path name and set it to "..."
   WHILE j < k: i = m: m = INSTR(i + 1, s, "\"): INCR j: WEND
   f = LEFT$(s, i) + "..." + MID$(s, m)
   k = (PARSECOUNT(s, "\") + 1) MOD 2
   DO WHILE sz.cx > w AND TALLY(f, "\") > 2
      INCR k
      IF k MOD 2 THEN
         REPLACE "...\" + PARSE$(f, "\", j + 1) WITH "..." IN f
      ELSE
         REPLACE PARSE$(f, "\", j - 1) + "\..." WITH "..." IN f: DECR j
      END IF
      GetTextExtentPoint32 hdc, BYVAL STRPTR(f), BYVAL LEN(f), sz
   LOOP
   FUNCTION = f
END FUNCTION

SUB exceptions()
   LOCAL hExcept, nStyle AS LONG
   DIALOG NEW PIXELS, hDlg, "Folder Exceptions", , , 400, 300, %WS_SYSMENU TO hExcept
   nStyle = %CBS_SIMPLE OR %CBS_HASSTRINGS OR %WS_TABSTOP OR %WS_VSCROLL
   CONTROL ADD COMBOBOX, hExcept, %IDC_ComboX, , 5, 10, 390, 220, nStyle
   CONTROL ADD BUTTON, hExcept, %IDC_SuggestX, "Su&ggest", 20, 250, 60, 30
   CONTROL ADD BUTTON, hExcept, %IDC_AddX, "&Add", 100, 250, 60, 30
   CONTROL ADD BUTTON, hExcept, %IDC_DeleteX, "&Delete", 160, 250, 60, 30
   CONTROL ADD BUTTON, hExcept, %IDC_ClearX, "&Clear", 240, 250, 60, 30
   CONTROL ADD BUTTON, hExcept, %IDC_OkX, "&Ok", 300, 250, 60, 30
   DIALOG SHOW MODAL hExcept, CALL exceptProc
END SUB

CALLBACK FUNCTION exceptProc()
   LOCAL i, n AS LONG
   LOCAL s, ss AS STRING
   STATIC saveX, exceptChanged AS LONG
   STATIC saveExcept() AS STRING
   DIM suggest(1 TO 5) AS STRING
   suggest(1) = "\Temp\"
   suggest(2) = "\Cache"
   suggest(3) = "\Recycle Bin"
   suggest(4) = "\Temporary Internet Files\"
   suggest(5) = "\Mozilla\Firefox\"
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         REDIM saveExcept(numExcept)
         COMBOBOX RESET CB.HNDL, %IDC_ComboX
         FOR i = 1 TO numExcept
            COMBOBOX ADD CB.HNDL, %IDC_ComboX, except(i)
            saveExcept(i) = except(i)
         NEXT i
         saveX = 0
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_SuggestX THEN
            FOR i = 1 TO UBOUND(suggest)
               s = suggest(i)
               COMBOBOX FIND EXACT CB.HNDL, %IDC_ComboX, 1, s TO n
               IF n = 0 THEN
                  INCR numExcept: REDIM PRESERVE except(1 TO numExcept)
                  except(numExcept) = s
                  COMBOBOX ADD CB.HNDL, %IDC_ComboX, s
               END IF
            NEXT i
            CONTROL SET FOCUS CB.HNDL, %IDC_ComboX
            exceptChanged = 1
         ELSEIF CB.CTL = %IDC_AddX THEN
            CONTROL GET TEXT CB.HNDL, %IDC_ComboX TO s
            if len(s) = 0 then
                  ss = "Choose folder for exception"
                  DISPLAY BROWSE CB.HNDL, , , ss, "C:\", %BIF_NEWDIALOGSTYLE TO s
            end if    
            COMBOBOX FIND EXACT CB.HNDL, %IDC_ComboX, 1, s TO n
            IF n = 0 AND LEN(s) THEN 'no replicates, so ok to add
               COMBOBOX ADD CB.HNDL, %IDC_ComboX, s
               INCR numExcept: REDIM PRESERVE except(1 TO numExcept)
               except(numExcept) = s: exceptChanged = 1
            END IF
            CONTROL SET TEXT CB.HNDL, %IDC_ComboX, ""
            CONTROL SET FOCUS CB.HNDL, %IDC_ComboX
         ELSEIF CB.CTL = %IDC_DeleteX THEN
            COMBOBOX GET SELECT CB.HNDL, %IDC_ComboX TO n
            IF n THEN
               COMBOBOX GET TEXT CB.HNDL, %IDC_ComboX, n TO s
               COMBOBOX DELETE CB.HNDL, %IDC_ComboX, n
               ARRAY SCAN except(), = s, TO n
               ARRAY DELETE except(n)
               DECR numExcept
            END IF
            CONTROL SET FOCUS CB.HNDL, %IDC_ComboX
            exceptChanged = 1
         ELSEIF CB.CTL = %IDC_ClearX THEN
            COMBOBOX RESET CB.HNDL, %IDC_ComboX
            CONTROL SET FOCUS CB.HNDL, %IDC_ComboX
            numExcept = 0: exceptChanged = 1
         ELSEIF CB.CTL = %IDC_OkX THEN
            if exceptChanged then fileChanged = 1
            DIALOG END CB.HNDL: saveX = 1
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            IF saveX = 0 THEN
               numExcept = UBOUND(saveExcept)
               REDIM except(1 TO numExcept)
               FOR i = 1 TO numExcept
                  except(i) = saveExcept(i)
               NEXT i
            END IF
         END IF
   END SELECT
   FOR i = 1 TO numExcept
      except(i) = LCASE$(except(i))
   NEXT i
END FUNCTION

SUB backupNow()
   LOCAL i, k, hFile AS LONG
   LOCAL s, ti AS STRING
   'first, check that target and source folders exist -------------------------------
   IF ISFOLDER(sCopyTo) = 0 THEN 'checking target
      s = sCopyTo
      MSGBOX "Cannot find specified target folder or device" + $crlf + $crlf + s, %MB_ICONERROR, "Target Error"
      EXIT SUB
   END IF
   FOR i = 1 TO numSources 'checking sources
      s = sources(i)
      IF LEN(s) = 0 OR ISFOLDER(s) = 0 THEN
         MSGBOX "Cannot find specified source folder or device" + $crlf + $crlf + s, %MB_ICONERROR, "Source Error"
         EXIT SUB
      END IF
   NEXT i
   IF run THEN ti = "Restore" ELSE ti = "Backup"
   s = "Begin " + ti + " procedure now?"
   k = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
   IF k = %IDYES THEN
      'now run backup or restore ----------------------------------------------------
      CONTROL SET TEXT hDlg, %IDC_Backup, "&Stop"
      copyLog = ti + " date: " + DATE$
      copyLog = copyLog + $crlf + ti + " time: " + TIME$
      copyLog = copyLog + $crlf + "Backup File: " + thisFile
      copyLog = copyLog + $crlf
      
      KILL dataFolder + "myBackup.log"
      logFile = FREEFILE: numErrors = 0
      OPEN dataFolder + "myBackup.log" FOR OUTPUT AS logFile
      PRINT #logFile, ti + " date: " + DATE$
      PRINT #logFile, ti + " time: " + TIME$
      PRINT #logFile, "Backup File: " + thisFile
      PRINT #logFile, ""

      start = TIMER: numFiles = 0
      IF run THEN restoreFiles ELSE backupFiles
      showResults: fileBackedUp = 1
   END IF
END SUB

SUB showResults()
   LOCAL t, hh, mm, ss AS DOUBLE
   LOCAL s, s1, ti, sTime AS STRING
   t = TIMER - start
   hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
   IF hh >= 1 THEN
      mm = mm + ss/60
      sTime = FORMAT$(hh,"0") + " hours and " + FORMAT$(mm,"0.00") + " minutes"
   ELSEIF mm >= 1 THEN
      mm = mm + ss/60
      sTime = sTime + FORMAT$(mm,"0.00") + " minutes"
   ELSEIF ss > 1 THEN
      sTime = sTime + FORMAT$(ss,"0") + " seconds"
   ELSE
      sTime = "less than a second"
   END IF
   IF running THEN
      s1 = "Backup completed": running = 0
   ELSE
      s1 = "Backup Interrupted": running = 0
      IF nErr = %ERR_DISKFULL THEN s1 = s1 + " - Disk full"
   END IF
   s = s1 + $CRLF + STR$(numFiles) + " files copied in " + sTime
   IF run THEN ti = "Restore" ELSE ti = "Backup"
   MSGBOX s, %MB_ICONINFORMATION, ti
   CONTROL SET TEXT hDlg, %IDC_Backup, "Backup"
   resetStatusbar
   
   OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
   PRINT #logFile, ""
   PRINT #logFile, s1
   PRINT #logFile, STR$(numFiles) + " files copied in " + sTime + " to " + sCopyTo
   CLOSE #logFile
   copyLog = copyLog + $crlf 
   copyLog = copyLog + $crlf + s1
   copyLog = copyLog + $crlf + STR$(numFiles) + " files copied in " + sTime + " to " + sCopyTo
   run = 0
END SUB

SUB backupFiles()
   'copy files from multiple source folders to a single target folder
   'here is an example of backing up one source folder:
   '  copyTo = "F:\myBackup\HP Laptop\"
   '  source = "C:\Users\All Users\cgdSoftware\"
   '  target = "F:\myBackup\HP Laptop\" + "Users\All Users\cgdSoftware\"
   '------------------------------------------------------------------------
   LOCAL i, j, k, n, x, y, xx, yy AS LONG
   LOCAL s AS STRING
   LOCAL r AS RECT
   running = 1: numFiles = 0
   'prevent sleep and hybernation mode
   i = %ES_CONTINUOUS OR %ES_SYSTEM_REQUIRED
   j = i OR %ES_AWAYMODE_REQUIRED
   if SetThreadExecutionState(j) = 0 then
      SetThreadExecutionState(i)
   end if
   FOR i = 1 TO numSources 'now perform the backup
      k = ListView_GetCheckState(hListview, i - 1)
      IF k AND running THEN
         OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
         PRINT #logFile
         PRINT #logFile, sources(i)
         CLOSE #logFile
         sSource = sources(i)
         n = INSTR(sSource, "\"): s = MID$(sSource, n + 1)
         sTarget = sCopyTo + s
         STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, sSource
         STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, "   "
         totalCount = sizeDir(sSource, -1)
         nProgress = MAX(totalCount\50, 1)
         nCount = 0: lastTime = 0: nTextbox = i
         '-------------- position progress bar over listview row i
         r.nLeft = %LVIR_LABEL
         n = SendMessage (hListview, %LVM_GETITEMRECT, i - 1, VARPTR(r))
         DIALOG PIXELS hListview, r.nLeft, r.nTop TO UNITS x, y
         DIALOG PIXELS hListview, r.nRight, r.nBottom TO UNITS xx, yy
         IF %PB_REVISION = &H1004 THEN SWAP x, y: SWAP xx, yy
         CONTROL SET LOC hDlg, %IDC_Textbox, x + 23, y + 61
         CONTROL SET SIZE hDlg, %IDC_Textbox, xx - x - 3, yy - y
         CONTROL SET TEXT hDlg, %IDC_Textbox, sources(i)
         '-------------- copy files that have changed in sSource
         copyDir sSource
         IF running THEN progress hTextbox, 1.0
         ListView_SetCheckState hListview, i - 1, 0
         lastDate(i) = VAL(REMOVE$(DATE$, "-"))
      END IF
   NEXT i
   SetThreadExecutionState(%ES_CONTINUOUS)
END SUB

SUB restoreFiles()
   'restore files from target folder to original source folders
   'here is an example of restoring one target folder:
   '  copyTo = "F:\my Backup\HP Laptop\"
   '  source = "F:\myBackup\HP Laptop\" + "Users\All Users\cgdSoftware\"
   '  target = "C:\Users\All Users\cgdSoftware\"
   '------------------------------------------------------------------------
   LOCAL i, j, k, n, x, y, xx, yy AS LONG
   LOCAL s AS STRING
   LOCAL r AS RECT
   running = 2: numFiles = 0
   'prevent sleep and hybernation mode
   i = %ES_CONTINUOUS OR %ES_SYSTEM_REQUIRED
   j = i OR %ES_AWAYMODE_REQUIRED
   if SetThreadExecutionState(j) = 0 then
      SetThreadExecutionState(i)
   end if
   FOR i = 1 TO numSources 'now perform the restore
      k = ListView_GetCheckState(hListview, i - 1)
      IF k AND running THEN
         sSource = sources(i)
         n = INSTR(sSource, "\"): s = MID$(sSource, n + 1)
         sTarget = LEFT$(sSource, n) + s:  sSource = sCopyTo + s
         SWAP sSource, sTarget
         STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, sTarget
         STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, "   "
         totalCount = sizeDir(sTarget, -1)
         nProgress = MAX(totalCount\50, 1)
         nCount = 0: lastTime = 0: nTextbox = i
         '-------------- position progress bar over listview row i
         r.nLeft = %LVIR_LABEL
         n = SendMessage (hListview, %LVM_GETITEMRECT, i - 1, VARPTR(r))
         DIALOG PIXELS hDlg, r.nLeft, r.nTop TO UNITS x, y
         DIALOG PIXELS hDlg, r.nRight, r.nBottom TO UNITS xx, yy
         IF %PB_REVISION = &H1004 THEN SWAP x, y: SWAP xx, yy
         CONTROL SET LOC hDlg, %IDC_Textbox, x + 23, y + 61
         CONTROL SET SIZE hDlg, %IDC_Textbox, xx - x - 3, yy - y
         CONTROL SET TEXT hDlg, %IDC_Textbox, sources(i)
         '-------------- copy files that have changed in sSource
         copyDir sSource
         IF running THEN progress hTextbox, 1.0
         ListView_SetCheckState hListview, i - 1, 0
      END IF
   NEXT i
   SetThreadExecutionState(%ES_CONTINUOUS)
END SUB

SUB copyDir(BYVAL sPath AS STRING)
   'recursively finds and copies all files in sSource to sTarget
   'first call is made without the flag
   'code by Casey Sprangel of www.ifxGroup.net, modified by Charles Dietz
   '------------------------------------------------------------------------
   local fileSize, big AS dword, p as double
   LOCAL s, s1, ssPath, sDateMod, sDateMod1, fn, f AS STRING
   LOCAL i, hSearch, hSrch AS LONG           'search handles
   LOCAL WFD, WFD1 AS WIN32_FIND_DATA        'find file data structure (WFD for source, WFD1 for target)
   LOCAL mask AS ASCIIZ * %MAX_PATH          'what to search for
   local folderX as long                     'folder exception
   dim buff(8192) as byte

   big = 10000000
   sPath = RTRIM$(sPath, "\") + "\"            'add backslash if not there
   ssPath = MID$(sPath, LEN(sSource) + 1)      'part of sPath extended by recursion
   createFolder sTarget + ssPath
   mask = sPath + "*.*"                        'mask lists where and what files to find
   hSearch = FindFirstFile(mask, WFD)          'get handle of first file found
   IF hSearch <> %INVALID_HANDLE_VALUE THEN    'loop through directory for files
      DO
         IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
            folderX = 0
            IF WFD.cFileName <> "." AND WFD.cFileName <> ".." THEN
               s = LCASE$(sPath + WFD.cFileName)
               FOR i = 1 TO numExcept
                  IF INSTR(s, except(i)) then folderX = 1: ITERATE DO
               NEXT i
               copyDir s
            END IF
         ELSE 'this is a file... so copy it
            fn = WFD.cFileName
            sDateMod = getFileDateTime(WFD.ftLastWriteTime): sDateMod1 = "00000000"
            'determine modify date of corresponding target file
            hSrch = FindFirstFile(sTarget + ssPath + fn, WFD1)
            IF (hSrch > 0) AND _
            (WFD1.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY) <> %FILE_ATTRIBUTE_DIRECTORY THEN
               sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
            END IF
            'copy if backing-up file with later date, or restoring
            IF running AND (sDateMod > sDateMod1 OR run) THEN 'copy file
               s = fitLongFileName(hStatusbarDC, f, statusbarLen)
               STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, s
               fileSize = MAK(QUAD, WFD.nFileSizeLow, WFD.nFileSizeHigh) + clusterSize
               f = sPath + fn
               incr nCount
               if fileSize > big then
                  fileBlockCopy(f, sTarget + ssPath + fn, 65536)
               else   
                  FILECOPY f, sTarget + ssPath + fn
                  updateStatus
               end if
               nErr = ERRCLEAR: IF nErr = %ERR_DISKFULL THEN running = 0
               'print results to myBackup.log ---------------------------------------------------
               IF nErr THEN
                  s1 = "ERROR - " + ERROR$(nErr)
               ELSE
                  sDateMod1 = ""
                  hSrch = FindFirstFile(sTarget + ssPath + fn, WFD1): FindClose hSrch
                  IF hSrch > 0 THEN sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
                  IF LEN(sDateMod1) OR run THEN 'copied to target
                     INCR numFiles: s1 = ""
                  ELSE 'not copied to target
                     s1 = "Error - Possible virus detected"
                  END IF
               END IF
               copyLog = copyLog + $CRLF + f
               if len(s1) then copyLog = copyLog + $crlf + s1
               OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
               PRINT #logFile, f
               IF LEN(s1) THEN PRINT #logFile, s1
               CLOSE #logFile
            else 'do not copy file
               incr nCount: updateStatus
            END IF
         END IF
         if running <= 0 then 'interrupted or cancelled
            control set text hDlg, %IDC_Waiting, "": exit sub
         end if
      LOOP WHILE FindNextFile(hSearch, WFD)
   END IF
   FindClose hSearch
END SUB

function fileBlockcopy(sSource as string, sTarget as string, buffSize as dword) as dword
   'copies file in blocks using win32API... useful when needing more continuous status 
   'sSource: file to copy
   'sTarget: file target of copy
   'buffSize: size of blocks to copy (eg. 8192, 65536, 1000000)
   'returns bytes copied
   'returns -1 if sSource not found, -2 if sTarget folder not found
   '-------------------------------------------------------------------------------------------
   local fSource, fTarget as asciiz * 128
   local hSource, hTarget, hTemplateFile, totalBytes as dword
   local bytesRead, bytesWritten as dword, nErr as long
   local pBuff as byte ptr, psa as SECURITY_ATTRIBUTES ptr
   local ofs as OFSTRUCT  ', saStruct as SECURITY_ATTRIBUTES
   if isfile(sSource) = 0 then _
      function = -1: end
   if isfolder(pathname$(path, sTarget)) = 0 then _
      function = -2: end
   dim buff(buffSize) as byte
   fSource = sSource
   fTarget = sTarget
   hSource = openFile(fSource, ofs, %OF_READ)
   hTarget = createFile(fTarget, byval %GENERIC_WRITE, byval 0, byval psa, BYVAL %CREATE_ALWAYS, _
      BYVAL %FILE_ATTRIBUTE_NORMAL, byval htemplateFile)
   pBuff = varptr(buff(0))
   do
      nErr = ReadFile(hSource, byval pBuff, buffSize, bytesRead, byval 0)
      if nErr = 0 then bytesRead = 0
      if bytesRead > 0 then 
         nErr = WriteFile(hTarget, pBuff, bytesRead, bytesWritten, byval 0)
         if nErr = %INVALID_HANDLE_VALUE THEN bytesWritten = 0
      else
         bytesWritten = 0
      end if
      totalBytes = totalBytes + bytesWritten
      updateStatus
      if running <= 0 then 'interrupted or cancelled
         control set text hDlg, %IDC_Waiting, "Waiting for file copying to finish..."
      end if 
   loop while (bytesRead > 0) and (bytesRead = bytesWritten)
   _lclose(hSource)
   _lclose(hTarget)
   function = totalBytes
end function

sub updateStatus()
   LOCAL t, hh, mm, ss AS LONG 
   LOCAL s, hrs, mins, secs, sTime AS STRING
   local p as double
   DIALOG DOEVENTS 0: 
   t = TIMER - start  'number of seconds since midnight
   hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
   secs = FORMAT$(ss, "00"): s = " Seconds: "
   IF mm THEN mins = FORMAT$(mm, "00") + ":": s = " Minutes: "
   IF hh THEN hrs = FORMAT$(hh, "00") + ":": s = " Hours: "
   sTime = s + LTRIM$(hrs + mins + secs, "0")
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, sSource
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, "   " + sTime
   IF nProgress >= 1 AND (nCount MOD nProgress) = 0 _
   OR (TIMER - start) >= (lastTime + 1) THEN
      lastTime = TIMER - start
      p = nCount/totalCount: progress hTextbox, p
      STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 3, 0, "   " + STR$(INT(100 * p)) + "%"
   END IF
end sub

FUNCTION sizeDir(BYVAL sPath AS STRING, qReqd AS QUAD, OPT BYVAL flag AS BYTE) AS LONG
   'return total number and total size of files in this folder plus all sub folders
   'call dirFiles with flag = 1 if file size is needed (file sizes rounded up to nearest cluster size)
   'code by Casey Sprangel of www.ifxGroup.net, modified by Charles Dietz
   '----------------------------------------------------------------------------------------------------
   LOCAL hSearch, hSrch AS LONG              'search handle
   LOCAL WFD, WFD1 AS WIN32_FIND_DATA        'find file data structure (WFD for source, WFD1 for target)
   LOCAL mask AS ASCIIZ * %MAX_PATH          'what to search for
   LOCAL i, n, t, hh, mm, ss AS LONG
   LOCAL qSource, qTarget AS QUAD
   LOCAL sTime, secs, mins, hrs AS STRING
   LOCAL s, ssPath, fn, sDateMod, sDateMod1 AS STRING
   LOCAL sectPerClus, bytesPerSect, dummy AS DWORD
   STATIC nFiles, nCluster, folderX AS LONG
   STATIC qTot AS QUAD

   IF flag < 2 THEN 'initialize
      flag = flag + 2
      qTot = MIN(qReqd, 0): nFiles = 0
      n = GetDiskFreeSpace("c:\", sectPerClus, bytesPerSect, clusterSize, dummy)
      clusterSize = sectPerClus * bytesPerSect
      nCluster = LOG(clusterSize)/LOG(2) + .5
   END IF
   t = TIMER - start
   hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
   secs = FORMAT$(ss, "00"): s = " Seconds: "
   IF mm THEN mins = FORMAT$(mm, "00") + ":": s = " Minutes: "
   IF hh THEN hrs = FORMAT$(hh, "00") + ":": s = " Hours: "
   sTime = s + LTRIM$(hrs + mins + secs, "0")
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, sSource
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, "   " + sTime

   sPath = RTRIM$(sPath, "\") + "\"                   'add backslash if not there
   ssPath = MID$(sPath, LEN(sSource) + 1)             'part of sPath extended by recursion
   mask = sPath + "*.*"                               'mask lists where and what files to find
   hSearch = FindFirstFile(mask, WFD)                 'get handle of first file found
   IF hSearch <> %INVALID_HANDLE_VALUE THEN           'loop through directory for files
      DO
         DIALOG DOEVENTS 0: IF running <= 0 THEN EXIT FUNCTION
         fn = WFD.cFileName
         IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
            folderX = 0
            IF fn <> "." AND fn <> ".." THEN
               s = LCASE$(sPath + fn)
               FOR i = 1 TO numExcept
                  IF INSTR(s, except(i)) THEN folderX = 1: ITERATE DO
               NEXT i
               sizeDir s, qReqd, flag
            END IF
         ELSEIF flag = 2 THEN
            if folderX then iterate do else INCR nFiles
         ELSE 'need filesize (flag = 3)
            if folderX then iterate do else INCR nFiles
            sDateMod = getFileDateTime(WFD.ftLastWriteTime): sDateMod1 = "00000000"
            'determine modify date of corresponding target file
            hSrch = FindFirstFile(sTarget + ssPath + fn, WFD1)
            IF (hSrch > 0) AND _
            (WFD1.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY) <> %FILE_ATTRIBUTE_DIRECTORY THEN
               sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
            END IF
            IF sDateMod > sDateMod1 THEN
               qSource = MAK(QUAD, WFD.nFileSizeLow, WFD.nFileSizeHigh) + clusterSize
               SHIFT RIGHT qSource, 12: SHIFT LEFT qSource, 12
               qTarget = MAK(QUAD, WFD1.nFileSizeLow, WFD1.nFileSizeHigh) + clusterSize
               SHIFT RIGHT qTarget, 12: SHIFT LEFT qTarget, 12
               qTot = qTot + qSource - qTarget
            END IF
            s = fitLongFileName(hStatusbarDC, sPath + fn, statusbarLen)
            STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, s
            FindNextFile(hSrch, WFD1)
         END IF
      LOOP WHILE FindNextFile(hSearch, WFD)
   END IF
   FindClose hSearch
   FUNCTION = nFiles
   qReqd = qTot
END FUNCTION

SUB getReqdSpace()
   'check required space for the target
   LOCAL t, hh, mm, ss AS DOUBLE
   LOCAL s, s1, hrs, mins, secs, sTime, sMsg AS STRING
   LOCAL i, k, n AS LONG
   LOCAL qReqd, q AS QUAD

   CONTROL SET TEXT hDlg, %IDC_Backup, "&Stop"
   start = TIMER
   FOR i = 1 TO numSources
      k = ListView_GetCheckState(hListview, i - 1)
      IF k THEN
         sSource = sources(i)
         n = INSTR(sSource, "\"): s = MID$(sSource, n + 1)
         sTarget = sCopyTo + s
         running = 1: q = 0
         n = sizeDir(sSource, q, 1)
         IF running = 0 THEN EXIT FOR
         sMsg = sMsg + "Source" + STR$(i) + ":  " + FORMAT$(q, "#,") + $CRLF
         qReqd = qReqd + q
      END IF
   NEXT i
   IF running < 0 THEN EXIT SUB
   IF LEN(sMsg) THEN sMsg = sMsg + $CRLF
   CONTROL SET TEXT hDlg, %IDC_Backup, "Backup"
   resetStatusbar
   t = MAX(TIMER - start, 1)
   hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
   secs = FORMAT$(ss,"00"): s = " Seconds"
   IF mm THEN mins = FORMAT$(mm,"00") + ":": s = " Minutes"
   IF hh THEN hrs = FORMAT$(hh,"00") + ":": s = " Hours"
   sTime = LTRIM$(hrs + mins + secs, "0") + s
   sMsg = sMsg + "Total free space required:   " + FORMAT$(qReqd, "#,") + $CRLF
   sMsg = sMsg + "Total free space available:  "
   s = LEFT$(sCopyTo, 2)
   IF s = "\\" THEN
      sMsg = sMsg + "Consult network drive manufacturer"
   ELSE
      sMsg = sMsg + FORMAT$(DISKFREE(s), "#,")
   END IF
   IF running THEN s1 = "Completed" ELSE s1 = "Interrupted"
   sMsg = sMsg + $CRLF + $CRLF + s1 + " at " + sTime
   MSGBOX sMsg, %MB_ICONINFORMATION, "Required Space"
   run = 0: running = 0
END SUB

SUB progress(hText AS LONG, pct AS DOUBLE)
   'smooth progress bar with text
   'hText = handle of textbox
   'pct = percent progress, -1 to clear
   '------------------------------------------------------------
   LOCAL hParent, n AS LONG
   LOCAL xb, yb, wb, hb, xc, yc, wc, hc, xt, yt AS LONG
   LOCAL hdc, hRgn, hFont, hBrush AS LONG
   LOCAL sz AS ASCIIZ * 1024
   LOCAL pt AS POINT, rBox, tBox AS RECT

   pct = MIN(pct, 1): IF pct = 0 THEN EXIT SUB
   'get location and size of client textbox
   n = GetWindowTextLength(hText)
   GetWindowText hText, sz, n + 1
   hParent = GetParent(hText)
   ClientToScreen hParent, pt
   GetWindowRect hText, rBox
   xb = rBox.nLeft - pt.x: yb = rBox.nTop - pt.y
   wb = rBox.nRight - rBox.nLeft: hb = rBox.nBottom - rBox.nTop
   GetClientRect hText, rBox
   wc = rBox.nRight: hc = rBox.nBottom
   xc = xb + (wb - wc)/2: yc = yb + (hb - hc)/2

   'paint progress area of textbox
   hdc = getDC(hParent)
   hBrush = CreateSolidBrush(%RGB_LIGHTBLUE)
   hRgn = CreateRectRgn(xc, yc, xc + wc * pct, yc + hc)
   FillRgn hdc, hRgn, hBrush
   DeleteObject hBrush
   DeleteObject hRgn
   ReleaseDC hParent, hdc

   'print the text back onto the progress area
   hdc = getDC(hText)
   hFont = SendMessage(hText, %WM_GETFONT, 0, 0)
   SelectObject(hdc, hFont)
   SendMessage hText, %EM_GETRECT, 0, VARPTR(tBox)
   xt = tBox.nLeft: yt = tBox.nTop
   SetBkMode(hdc, %TRANSPARENT)
   TextOut hdc, xt, yt, BYVAL VARPTR(sz), LEN(sz)
   ReleaseDC hText, hdc
END SUB

SUB createFolder(BYVAL folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s, sNet AS STRING
   IF LEFT$(folder, 2) = "\\" THEN 'UNC network path
      sNet = "\\": folder = MID$(folder, 3)
   END IF
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(sNet + s) = 0 THEN MKDIR sNet + s
      END IF
   NEXT i
END SUB

FUNCTION getFileDateTime(dt AS FILETIME) AS STRING
   'return string: year & month & day & hour & minute
   '------------------------------------------------------------------
   LOCAL lpsystime AS SYSTEMTIME
   LOCAL sDate AS ASCIIZ * 32 'date buffer
   LOCAL sTime AS ASCIIZ * 32 'time buffer

   'set the last modified date & time
   CALL FileTimeToLocalFileTime(dt, dt)
   CALL FileTimeToSystemTime(dt, lpsystime)

   CALL GetDateFormat(%LOCALE_SYSTEM_DEFAULT, %DATE_SHORTDATE, BYVAL VARPTR(lpsystime), _
                       BYVAL %NULL, sDate, 32)
   CALL GetTimeFormat(%LOCALE_SYSTEM_DEFAULT, %TIME_FORCE24HOURFORMAT OR %TIME_NOSECONDS, _
                       BYVAL VARPTR(lpsystime), BYVAL %NULL, sTime, 32)
   FUNCTION = PARSE$(sDate, "/", 3) _
            + RIGHT$("0" + PARSE$(sDate, "/", 1), 2) _
            + RIGHT$("0" + PARSE$(sDate, "/", 2), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 1), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 2), 2)
END FUNCTION

SUB openTheFile(f AS STRING)
   LOCAL hFile, i, n AS LONG
   LOCAL t AS DOUBLE
   IF ISFILE(f) THEN 'file exists... so, open it
      hFile = FREEFILE
      OPEN f FOR BINARY AS #hFile
      GET #hFile,, numSources
      REDIM sources(numSources)
      REDIM lastDate(numSources)
      GET #hFile,, n: sCopyTo = SPACE$(n): GET #hFile,, sCopyTo
      FOR i = 1 TO numSources
         GET #hFile,, n: sources(i) = SPACE$(n): GET #hFile,, sources(i)
         sources(i) = RTRIM$(sources(i), "\") + "\"
      NEXT i
      lastDatePos = SEEK(#hFile)
      FOR i = 1 TO numSources
         GET #hFile,, lastDate(i)
      NEXT i
      GET #hFile,, numExcept
      REDIM except(1 TO numExcept)
      FOR i = 1 TO numExcept
         GET #hFile,, n: except(i) = SPACE$(n): GET #hFile,, except(i)
      NEXT i
      CLOSE #hFile
   ELSE 'new file
      numSources = 0
      REDIM sources(0)
      sCopyTo = ""
   END IF
   '---------- fill out the dialog form and statusbar
   CONTROL SET TEXT hDlg, %IDC_TargetTxt, sCopyTo
   LISTVIEW RESET hDlg, %IDC_Listview
   FOR i = 1 TO numSources
      LISTVIEW INSERT ITEM hDlg, %IDC_Listview, i, 0, sources(i)
      ListView_SetCheckState hListview, i - 1, 1
   NEXT i
   CONTROL SET TEXT hDlg, %IDC_SetCkboxes, "Clear Selection"
   LISTVIEW VISIBLE hDlg, %IDC_Listview, 1
   resetStatusbar
END SUB

SUB saveIniFile()
   'save last four recent files
   LOCAL fileNo, j AS LONG
   LOCAL s AS STRING
   s = LCASE$(PARSE$(thisFile, "\", -1))
   ARRAY SCAN recent(), = s, TO j
   IF j THEN ARRAY DELETE recent(j)
   ARRAY INSERT recent(), s
   fileNo = FREEFILE
   OPEN iniFile FOR OUTPUT AS fileNo
   PRINT #fileNo, recent()
   CLOSE #fileNo
END SUB

SUB saveTheFile()
   LOCAL hFile, i, n AS LONG
   IF LEN(PATHNAME$(NAMEX, thisFile)) = 0 THEN saveAsFile
   saveIniFile: KILL thisFile
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS #hFile
   PUT #hFile,, numSources
   n = LEN(sCopyTo): PUT #hFile,, n: PUT #hFile,, sCopyTo
   FOR i = 1 TO numSources
      n = LEN(sources(i)): PUT #hFile,, n: PUT #hFile,, sources(i)
   NEXT i
   lastDatePos = SEEK(#hFile)
   FOR i = 1 TO numSources
      PUT #hFile, ,lastDate(i)
   NEXT i
   PUT #hFile,, numExcept
   FOR i = 1 TO numExcept
      n = LEN(except(i)): PUT #hFile,, n: PUT #hFile,, except(i)
   NEXT i
   CLOSE #hFile
   fileChanged = 0
END SUB

SUB saveAsFile()
   LOCAL flags AS LONG
   LOCAL f, ti, folder, filter AS STRING
   ti = "Save File": folder = dataFolder
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("myBackup", 0, "*.bku", 0, "All Files", 0, "*.*", 0)
   DISPLAY SAVEFILE hDlg,,, ti, folder, filter, "", "bku", flags TO f
   IF LEN(f) THEN
      thisFile = f: saveTheFile: resetStatusbar
   END IF
END SUB

SUB autoIntervalDlg()
   LOCAL hInterval, n AS LONG
   LOCAL s AS STRING
   DIALOG NEW hDlg,"Automatic Backups",,, 220, 160, %WS_SYSMENU TO hInterval
   s = "Select interval and beginning date:"
   CONTROL ADD LABEL, hInterval, -1, s, 10, 10, 200, 12
   CONTROL ADD OPTION, hInterval, %IDC_Interval+1, "Daily", 20, 30, 60, 12
   CONTROL ADD OPTION, hInterval, %IDC_Interval+2, "Weekly", 20, 45, 60, 12
   CONTROL ADD OPTION, hInterval, %IDC_Interval+3, "Bi-Weekly", 20, 60, 60, 12
   CONTROL ADD OPTION, hInterval, %IDC_Interval+4, "4-weeks", 20, 75, 60, 12
   CONTROL ADD LABEL, hInterval, -1, "Beginning...", 100, 50, 60, 12
   CONTROL ADD TEXTBOX, hInterval, %IDC_AutoBegin, DATE$, 100, 60, 60, 12
   CONTROL ADD BUTTON, hInterval, %IDOK, "Ok", 120, 100, 50, 25
   DIALOG SHOW MODAL hInterval, CALL autoIntervalDlgProc
END SUB

CALLBACK FUNCTION autoIntervalDlgProc()
   LOCAL i, j, day, mo, yr AS LONG
   LOCAL s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         autoInterval = 0: autoBegin = "00-00-0000"
         CONTROL SET OPTION CB.HNDL, %IDC_Interval+1, %IDC_Interval+1, %IDC_Interval+4
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            CONTROL GET TEXT CB.HNDL, %IDC_AutoBegin TO autoBegin
            day = VAL(PARSE$(autoBegin, ANY "-/", 2)): mo = VAL(PARSE$(autoBegin, ANY "-/", 1))
            yr = VAL(PARSE$(autoBegin, ANY "-/", 3)): IF yr < 100 THEN yr = 2000 + yr
            autoBegin = FORMAT$(mo, "00-") + FORMAT$(day, "00-") + FORMAT$(yr, "0000")
            FOR i = 1 TO 4
               CONTROL GET CHECK CB.HNDL, %IDC_Interval+i TO j
               IF j THEN EXIT FOR
            NEXT i
            'use 28 day month so that auto backup occurs on same day of week
            autoInterval = CHOOSE&(i, 1, 7, 14, 28)
            DIALOG END CB.HNDL
        END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN DIALOG END CB.HNDL
   END SELECT
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   FUNCTION = days
END FUNCTION

FUNCTION createShortcut(CSIDL AS DWORD, link AS STRING, SOURCE AS STRING, workDir AS STRING) AS LONG
    'adapted from Edwin Knoppert's code 07-10-03
    'http://www.powerbasic.com/support/forums/Forum7/HTML/001980.html
    'CSIDL   - CSIDL_DESKTOP, CSIDL_PROGRAMS, CSIDL_STARTUP, etc
    'link    - link file to be created like "My calc.lnk"
    'source  - file/document where the shortcut should point to like "c:\windows\calc.exe".
    'workDir - folder where the executable document/file should start in, best not to leave empty.
    '===============================================================================================
    LOCAL CLSID_ShellLink AS STRING * 16
    LOCAL IID_IShellLink  AS STRING * 16
    LOCAL IID_Persist     AS STRING * 16
    LOCAL nResult AS LONG, pShellLnk AS DWORD PTR, pPersist AS DWORD PTR
    LOCAL sLink AS STRING, szUniLnkName AS ASCIIZ * (2 * %MAX_PATH)
    LOCAL sArguments AS STRING, sComment AS STRING

    CLSID_ShellLink = MKL$(&H00021401) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    IID_IShellLink  = MKL$(&H000214EE) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    IID_Persist     = MKL$(&H0000010B) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    sArguments = "": sComment = ""
    CoInitialize BYVAL 0&

    IF CoCreateInstance(BYVAL VARPTR(CLSID_ShellLink), BYVAL 0&, 1, BYVAL VARPTR(IID_IShellLink), pShellLnk) = 0 THEN
        '// IShellLink::SetPath
        CALL DWORD @@pShellLnk[20] USING IShellLink_Call1(pShellLnk, STRPTR(SOURCE))
        '// IShellLink::SetsArguments
        CALL DWORD @@pShellLnk[11] USING IShellLink_Call1(pShellLnk, STRPTR(sArguments))
        '// IShellLink::SetWorkingDirectory
        CALL DWORD @@pShellLnk[9] USING IShellLink_Call1(pShellLnk, STRPTR(workDir))
        '// IShellLink::SetnShowCmd
        CALL DWORD @@pShellLnk[15] USING IShellLink_Call1(pShellLnk, %SW_SHOW)
        '// IShellLink::SetDescription
        CALL DWORD @@pShellLnk[7] USING IShellLink_Call1(pShellLnk, STRPTR(sComment))
        '// Obtain persist interface (QueryInterface)
        CALL DWORD @@pShellLnk[0] USING IShellLink_Call2(pShellLnk, VARPTR(IID_Persist), VARPTR(pPersist))

        IF nResult = %S_OK THEN
            '// Convert to unicode
            sLink = SpecialFolder(CSIDL) + "\" + link
            MultiByteToWideChar %CP_ACP, 0, BYVAL STRPTR(sLink), LEN(sLink), BYVAL VARPTR(szUniLnkName), %MAX_PATH * 2
            '// IPersistFile::Save
            CALL DWORD @@pPersist[6] USING IShellLink_Call2(pPersist, VARPTR(szUniLnkName), 1)
            '// Release
            CALL DWORD @@pPersist[2] USING IShellLink_Call0(pPersist)
        END IF
         '// Release
        CALL DWORD @@pShellLnk[2] USING IShellLink_Call0(pShellLnk)
        FUNCTION = -1
    END IF
    CoUninitialize
END FUNCTION

FUNCTION getProcID(progName AS STRING) AS DWORD
   'Enumerate Processes by Semen Matusovski
   'http://www.powerbasic.com/support/forums/Forum7/HTML/001497.html (08-03-2002)
   'return procID if found, 0 otherwise
   '=======================================================================================
   LOCAL hKernel32, hCreateToolhelp32Snapshot, hProcess32Next, hProcess32First AS DWORD
   LOCAL hModule32First, hModule32Next, hPsApiDll, hEnumProcesses, hProcessSnap AS DWORD
   LOCAL hGetModuleFileNameEx, hEnumProcessModules, nModules, cb, cbNeeded, i AS DWORD
   LOCAL nProcesses, hProcess, procID AS DWORD, lResult1 AS LONG, processName AS STRING
   LOCAL os AS OSVERSIONINFO, pe AS PROCESSENTRY32

   processName = LCASE$(progName)
   os.dwOSVersionInfoSize = SIZEOF(os)
   GetVersionEx BYVAL VARPTR(os)

   IF ISFALSE(os.dwPlatformId = %VER_PLATFORM_WIN32_NT) THEN 'Windows 95/98
      hKernel32                 = GetModuleHandle("kernel32.dll")
      hCreateToolhelp32Snapshot = GetProcAddress(hKernel32, "CreateToolhelp32Snapshot")
      hProcess32Next            = GetProcAddress(hKernel32, "Process32Next")
      hProcess32First           = GetProcAddress(hKernel32, "Process32First")
      hModule32First            = GetProcAddress(hKernel32, "Module32First")
      hModule32Next             = GetProcAddress(hKernel32, "Module32Next")

      CALL DWORD hCreateToolhelp32Snapshot USING CreateToolhelp32Snapshot(%TH32CS_SNAPPROCESS, 0&) TO hProcessSnap
      IF hProcessSnap <> %INVALID_HANDLE_VALUE THEN
         pe.dwSize = SIZEOF(pe)
         CALL DWORD hProcess32First USING Process32First(hProcessSnap, pe) TO lResult1
         DO WHILE lResult1
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = pe.th32ProcessID: EXIT DO
            END IF
            CALL DWORD hProcess32Next USING Process32Next(hProcessSnap, pe) TO lResult1
         LOOP
         CloseHandle hProcessSnap
     END IF

   ELSE 'Windows NT
      hPsApiDll = GetModuleHandle("psApi.dll")
      IF hPsApiDll = 0 THEN hPsApiDll = LoadLibrary("psApi.dll")
      hEnumProcesses       = GetProcAddress(hPsApiDll, "EnumProcesses")
      hGetModuleFileNameEx = GetProcAddress(hPsApiDll, "GetModuleFileNameExA")
      hEnumProcessModules  = GetProcAddress(hPsApiDll, "EnumProcessModules")

      cb = 100
      DO
         REDIM ProcessIDs(1 TO cb \ 4) AS DWORD
         CALL DWORD hEnumProcesses USING EnumProcesses (ProcessIDs(1), cb, cbNeeded) TO lResult1
         IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
      LOOP
      nProcesses = cbNeeded \ 4
      FOR i = 1 TO nProcesses
         hProcess = OpenProcess(%PROCESS_QUERY_INFORMATION OR %PROCESS_VM_READ, %False, ProcessIDs(i))
         IF hProcess THEN
            cb = 100
            DO
               REDIM Modules(1 TO cb / 4) AS DWORD
               CALL DWORD hEnumProcessModules USING EnumProcessModules(hProcess, Modules(1), cb, cbNeeded) TO lResult1
               IF lResult1 = 0 THEN cbNeeded = 0: ITERATE FOR
               IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
            LOOP
            nModules = cbNeeded / 4
            CALL DWORD hGetModuleFileNameEx USING GetModuleFileNameEx(hProcess, Modules(1), pe.szExeFile, SIZEOF(pe.szExeFile)) TO lResult1
            CloseHandle hProcess
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = ProcessIDs(i): EXIT FOR
            END IF
         END IF
      NEXT
   END IF
   FUNCTION = procID
END FUNCTION

SUB killProcess(progName AS STRING)
   LOCAL procID, hProcess AS DWORD
   procID = getProcID(progName)
   hProcess = OpenProcess(%PROCESS_TERMINATE, %false, procID)
   IF hProcess THEN
      TerminateProcess hProcess, 0
      Closehandle hProcess
   END IF
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

FUNCTION MakeFont(fontName AS STRING, fontSize AS LONG, OPT BYVAL fontAttr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL hDC, CyPixels, charHt, wt, nBold, underline, italic AS LONG
   IF LEN(fontAttr) THEN
      nBold = INSTR(fontAttr, "b") + 300
      underline = INSTR(fontAttr,"u")
      italic = INSTR(fontAttr,"i")
   END IF
   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (fontSize * CyPixels) \ 72
   wt = %FW_NORMAL + nBold
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

'-------------------------------------------------------------------------------------
'myMsgbox by Charles Dietz  02-14-05
'substitute for MS Windows Msgbox
'allow sound to be optional and desktop location to be specified
'-------------------------------------------------------------------------------------

FUNCTION myMsgBox(msg AS STRING, OPT BYVAL nStyle AS LONG, BYVAL ti AS STRING, _
                  BYVAL sound AS LONG, BYVAL x0 AS LONG, BYVAL y0 AS LONG) AS LONG
   'nStyle = %MB_OK               for 1 button:  Ok
   '       = %MB_YESNO            for 2 buttons: Ok, Cancel
   '       = %MB_OKCANCEL         for 2 buttons: Yes, No
   '       = %MB_YESNOCANCEL      for 3 buttons: Yes, No, Cancel
   '       = %MB_ICONERROR        for error icon (stop sign)
   '       = %MB_ICONINFORMATION  for information icon
   '       = %MB_ICONQUESTION     for question icon
   '       = %MB_ICONWARNING      for warning icon
   'ti = title and sound = 1 for beep, x0, y0 = desktop location
   'Returns %IDOK, %IDYES, %IDNO, or %IDCANCEL
   'Requires "WIN32API.INC"
   'Load this include file before myMsgbox is used
   '----------------------------------------------------------------------------
   LOCAL wi, ht, x, y, w, h, i, m, n, k, myMsgboxReturn AS LONG
   LOCAL hMsgBox, hParent, hdc, hIcon AS LONG
   LOCAL s AS STRING , ss AS STRING
   LOCAL rc AS RECT, t AS SIZEL

   hParent = GetActiveWindow
   DIALOG NEW PIXELS, hParent, ti, , , 200, 100 TO hMsgBox
   DIALOG SET COLOR hMsgBox, -1, %WHITE '%LTGRAY
   'size the message box and add controls  -------------------------------------
   hdc = GetDc(hMsgbox)
   ss = msg: n = 1 'm = max text length, n = lines of text
   DO: i = INSTR(ss, $CRLF): s = ss
       IF i THEN s = LEFT$(ss, i - 1): INCR n
       GetTextExtentPoint32 hdc, BYVAL STRPTR(s), LEN(s), t
       ss = MID$(ss, i + 2): m = MAX(m, t.cx)
   LOOP UNTIL i = 0
   ReleaseDC hMsgBox, hdc
   IF nStyle > 6 THEN k = 50 ELSE k = 10
   CONTROL ADD LABEL, hMsgBox, 9990, msg, k, 5, m, 15*n
   CONTROL SET COLOR hMsgBox, 9990, RGB(0, 0, 0), %WHITE  '%LTGRAY
   wi = MAX(220, m + k + 10): ht = MAX(120, 20*n + 55)
   m = nStyle MOD 16: n = ht - 70
   IF m = %MB_YESNOCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
      CONTROL ADD BUTTON, hMsgBox, 9993, "Cancel", 140, n, 60, 30
      CONTROL SET FOCUS hMsgbox, 9991
   ELSEIF m = %MB_YESNO THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30  ', %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
   ELSEIF m = %MB_OKCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Ok", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&Cancel", 75, n, 60, 30
   ELSE
      CONTROL ADD BUTTON, hMsgBox, 9994, "&Ok", 30, n, 80, 30, %BS_DEFAULT
   END IF
   'default location of msgbox -------------------------------------------------
   IF hParent THEN
      GetWindowRect hParent, rc: x = rc.nLeft: y = rc.nTop
      w = rc.nRight - rc.nLeft: h = rc.nBottom - rc.nTop
   ELSE
      DESKTOP GET CLIENT TO w, h
   END IF
   IF x0 OR y0 THEN
      x = MAX(x0, 0): y = MAX(y0, 0)
   ELSE
      x = x + (w - wi)/2: y = y + (h - ht)/2
   END IF
   MoveWindow hMsgbox, x, y, wi, ht, %TRUE
   'add icon to msgbox ---------------------------------------------------------
   CONTROL ADD LABEL, hMsgBox, 9995, "", 10, 5, 0, 0, %SS_ICON
   CONTROL SET COLOR hMsgBox, 9995, RGB(0, 0, 0), %WHITE  '%LTGRAY
   k = %MB_OK: m = nStyle - m
   IF m = %MB_ICONERROR THEN
      n = 103: k = %MB_ICONHAND
   ELSEIF m = %MB_ICONQUESTION THEN
      n = 102: k = %MB_ICONQUESTION
   ELSEIF m = %MB_ICONWARNING THEN
      n = 101: k = %MB_ICONEXCLAMATION
   ELSEIF m = %MB_ICONINFORMATION THEN
      n = 104: k = %MB_ICONASTERISK
   END IF
   hIcon = LoadImage(BYVAL 0, BYVAL n, %IMAGE_ICON, 32, 32, 0)
   SendDlgItemMessage hMsgBox, 9995, %STM_SETIMAGE, %IMAGE_ICON, hIcon
   '----------------------------------------------------------------------------
   IF sound THEN MessageBeep k
   DIALOG SHOW MODAL hMsgbox, CALL myMsgBoxProc TO myMsgboxReturn
   FUNCTION = myMsgBoxReturn
END FUNCTION

CALLBACK FUNCTION myMsgBoxProc()
   LOCAL ret AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SEND CBHNDL, 9991, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         SetWindowPos CBHNDL, %HWND_TOPMOST, 0,0,0,0, %SWP_NOMOVE OR %SWP_NOSIZE
      CASE %WM_COMMAND
         SELECT CASE CBCTL
         CASE 9991, %IDOK
            ret = %IDYES
         CASE 9992, %IDCANCEL
            ret = %IDNO
         CASE 9993
            ret = %IDCANCEL
         CASE 9994
            ret = %IDOK
         END SELECT
         DIALOG END CBHNDL, ret
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
SUB about
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hDlg,"My Backup Program",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "myBackup", 50, 10, 150, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 115, 13, 70, 10
   s = "Version " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 30, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 70, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 85, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "shield", 10, 20, 30, 30
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB

CALLBACK FUNCTION aboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CBMSG
   CASE %WM_PAINT
      hFont = makeFont("MS Sans Serif", 14)
      CONTROL SET COLOR CBHNDL, 9901, %RED, -1
      CONTROL SEND CBHNDL, 9901, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "i")
      CONTROL SEND CBHNDL, 9902, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10)
      CONTROL SEND CBHNDL, 9903, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 9904, %BLUE, -1
      CONTROL SEND CBHNDL, 9904, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 9905, %BLUE, -1
      CONTROL SEND CB.HNDL, 9905, %WM_SETFONT, hFont, 1
      DeleteObject hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(%NULL, BYVAL %IDC_HAND)
         SetWindowLong CBHNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      ELSEIF CBCTL = 9904 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CBCTL = 9905 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
